"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var cancelScrollEvent = function (e) {
    e.stopImmediatePropagation();
    e.preventDefault();
    e.returnValue = false;
    return false;
};
var addScrollEventListener = function (elem, handler) {
    elem.addEventListener('wheel', handler, false);
};
var removeScrollEventListener = function (elem, handler) {
    elem.removeEventListener('wheel', handler, false);
};
var ScrollLockMixin = {
    scrollLock: function (elem) {
        var _this = this;
        elem = elem || this.getDOMNode();
        this.scrollElem = elem;
        addScrollEventListener(elem, function (e) { return _this.onScrollHandler(e, elem); });
    },
    scrollRelease: function (elem) {
        var _this = this;
        elem = elem || this.scrollElem;
        removeScrollEventListener(elem, function (e) { return _this.onScrollHandler(e, elem); });
    },
    onScrollHandler: function (e, elem) {
        var scrollTop = elem.scrollTop;
        var scrollHeight = elem.scrollHeight;
        var height = elem.clientHeight;
        var wheelDelta = e.deltaY;
        var isDeltaPositive = wheelDelta > 0;
        if (isDeltaPositive && wheelDelta > scrollHeight - height - scrollTop) {
            elem.scrollTop = scrollHeight;
            return cancelScrollEvent(e);
        }
        else if (!isDeltaPositive && -wheelDelta > scrollTop) {
            elem.scrollTop = 0;
            return cancelScrollEvent(e);
        }
    }
};
exports.default = ScrollLockMixin;
//# sourceMappingURL=scrolllockmixin.js.map